//##############################################################################################
// Amandi's Webtool to display status of Senec, Solis and Growatt inverter
// Callback to server to read current values
// (C) 2021-2021 Ralf Amandi Systementwicklung and Avarix GmbH 
//  04.03.2021 V1.0
//  07.03.2022 V1.5 Code Cleanup 
//##############################################################################################

// in Milliseconds
var reqIntervall = 5000; 
var reqIntervallOnError = 20000;

// For calculating sun-raise
var Laengengrad = 7.55;
var Breitengrad = 50.34;

// Configuration auf the PV-strings to Display MPP values
// Please use the datahseet of your modules to set set value for volt
var pvModules = [ 
	{"cnt":6, "volt":34.69,"Wp":340,"color":"#FF0000"},
	{"cnt":11,"volt":34.69,"Wp":340,"color":"#00FF00"},
	{"cnt":12,"volt":34.69,"Wp":340,"color":"#0000FF"} ];

var dataUrl="./lala.cgi"; // where to fetch data
//var dataUrl="./wrapper.php?h=xx.xx.xx.xx";

var noChanges = true; // keine änderungen zulassen (sind eh im Wrapper blockiert)


