<?php
    #-----------------------------------------
    # Wrapper zum abrufen der Senec Daten 
    # (C) 28.10.2020 Ralf Amandi, Avarix GmbH
    # V 1.2  11.02.2021 Log File hinzugefügt    
    # V 1.21 07.07.2021 Anpassungen für PHP 7
    # V 1.41 05.11.2021 Beschränkung der übergebenen IP
    #-----------------------------------------
    $useCache=1;
    $cacheSecs=2;
    $allowPost=1; # 1= Post aus Request lesen, nur intern aktivieren
    $forceHost=""; # Host erzwingen
	
    $getStr=$_SERVER["QUERY_STRING"];
    $postStr='{"ENERGY":{},"STATISTIC":{},"DISPLAY":{},"FACTORY":{"DEVICE_ID":""},"PV1":{},"BMS":{"RECOVERLOCKED":"","VOLTAGE":["","","",""],"CURRENT":["","","",""]},"PM1OBJ1":{},"WIZARD":{"NET_SENEC_NO_NETWORK":"","SG_READY_CURR_MODE":""}}';
    if ($allowPost && $_SERVER["REQUEST_METHOD"] == "POST") {
		$postStr=file_get_contents('php://input');
    }
    #-- debuggen
    function WriteLog($txt)
    {
	global $_SERVER;
        $name=basename($_SERVER["PHP_SELF"]);
        $timeStr=date("Y.m.d H:i:s",time());
        #file_put_contents("tmp/".$name.".txt",$timeStr." ".$txt."\n",FILE_APPEND);
    }
    #---
    #WriteLog("\nT"." ".$_SERVER["HTTP_HOST"]." ".$_SERVER["HTTP_REFERER"]." ".$_SERVER["REQUEST_METHOD"]." ".$_SERVER["CONTENT_TYPE"]."\nG".$_SERVER["QUERY_STRING"]."\nP".$postStr);
    $host=$_GET['h'];
    $host=preg_replace("/^(\d+)$/","$1",$host); # nur Zahlen und punkt

    if ($host =="" || ($forceHost != "" && $host != $forceHost)) {
	http_response_code(500);
	exit;
    }
    
	#-- Log-File oder lala --
	if (array_key_exists("f",$_GET)) {
		$file=$_GET['f'];
		$file=preg_replace("/^([\d+\/])$/","$1",$file); # nur Zahlen und punkt
		$url="http://$host/log/".$file;
		$file=preg_replace("/\//","_",$file); # kein slash
		$cacheFile = "tmp/".$host."-".$file;
		header('Content-Type: text/plain; charset=UTF-8');
	} else {
		$cacheFile = "tmp/".$host;
		$url="http://$host/lala.cgi";
		header('Content-Type: application/json; charset=UTF-8');
	}
    # cache
		#WriteLog("X".$cacheFile	."|".$url."|");
    if ($useCache<>0 && file_exists($cacheFile) && (time()-filemtime($cacheFile))<$cacheSecs) {
	    $res = file_get_contents($cacheFile); 
		#WriteLog("Use Cache now: ".time()." file: ".filemtime($cacheFile)." diff: ".(time()-filemtime($cacheFile))." => ".$res);
    } else {	
		$options=array(
			'http' => array(
			'header' => "content-type: application/json\r\n",
			'method' => $_SERVER["REQUEST_METHOD"],
			'content' => $postStr
			)
		);
		$res=file_get_contents($url,false,stream_context_create($options));
		if ($useCache) {
			 file_put_contents($cacheFile,$res);
		}
			 file_put_contents($cacheFile,$res);
    }
    print $res;
?>